/*******************************************************************************
 * Copyright(c) 2021 dongke All rights reserved. / Confidential
 * 类的信息：
 *		1.程序名称：
 *		2.功能描述：新建其他出库
 * 编辑履历：
 *		作者				日期					版本				修改内容
 *		姜永辉	 2024年3月22日		     1.00		   	    一览
 *******************************************************************************/
const mixins = require('@/mixins/index.js');
const Constants = require('@/utils/Constants');
const util = require('@/utils/util.js')
const app = getApp()
Page({
    mixins: [mixins],
    /**
     * 页面的初始数据
     */
    data: {
        purIdArray: '',//来源单id 
        // 弹出按钮
        buttonList: [{
            name: 'merge',
            title: mixins.$t('save')
        }],
        contentList: [{
            code: 'flag',
            title: mixins.$t('antoOutHandle'),
            type: 'checkbox'
        }, {
            code: 'need',
            title: mixins.$t('totalAmount'),
            type: 'str'
        }, {
            code: 'amount',
            content: 0,
            type: 'number'
        }],
        btnFormData: null,
        //弹出pop
        popContent: [{
            code: 'itemQty',
            type: 'step',
            title: mixins.$t('count'),
            required: true
        },
        {
            code: 'whId',
            name: 'whName',
            title: mixins.$t('warehouseId'),
            type: 'choose',
            urlKey: 'openingInventory'
        },
        { code: 'skuSpec', title: mixins.$t('goodSpec'), type: 'str', readonly: true, },
        {
            code: 'nonStdCode',
            title: mixins.$t('goodsBatch'),
            type: 'str',
        },
        ],

        cardList: [{
            name: 'main',
            title: mixins.$t('outBoundInfo'),
        },
        {
            name: 'items',
            title: mixins.$t('goodsDetail'),
            info: '(' + mixins.$t('outboundProcessing') + ')',
            color: '#E4002B',
            itemAmt: 0,
            displayNum: 2
        }, {
            name: 'other',
            title: mixins.$t('otherInfo')
        }
        ],

        cardContentList: [
            { code: 'whId', name: 'whName', title: '库区', type: 'choose', }
        ],
        contentObj: {
            main: [
                {
                    code: 'outReason',
                    name: 'outReasonName',
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseStorageOutReason',
                    urlKeyParam: Constants.kindCode.basicOut
                },
                {
                    code: 'staffId',
                    name: 'staffName',
                    title: mixins.$t('responsiblePerson'),
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseStaff'
                }, {
                    code: 'orgId',
                    name: 'orgName',
                    title: mixins.$t('orgId'),
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseOrg'
                },
                {
                    code: 'outDate',
                    name: 'outDate',
                    type: 'date',
                    required: true,
                },
                {
                    code: 'outObject',
                    name: 'outObjectName',
                    title: mixins.$t('outObject'),
                    type: 'choose',
                    urlKey: 'chooseStorageObject'
                },
            ],

            items: [{
                code: 'collectType',
                name: 'collectName',
                type: 'drop',
                dropType: 'collect'
            }, {
                code: 'collectAmount',
                type: 'number',
                title: mixins.$t('totalAmount'),
            }],

            other: [{
                code: 'remarks',
                type: 'textarea',
                title: mixins.$t('remarks'),
                readonly: false
            }, {
                code: 'file',
                type: 'uploader',
                title: mixins.$t('uploader')
            }]
        },
        // 路由
        routeObjName: 'outboundOther',
        table: Constants.tables.outbound,
    },

    /**
      * @desc : 页面加载数据方法
      * @date : 2024/2/1 15:49
      * @author : 姜永辉
      */
    loadInit() {
        if (this.data.formMode == Constants.formMode.edit) {
            wx.setNavigationBarTitle({
                title: mixins.$t('editOtherOutWh'),
            })
        } else {
            wx.setNavigationBarTitle({
                title: mixins.$t('addOtherOutWh'),
            })
            // 新增
            if (this.data.formData == '{}') {
                this.setData({
                    formData: JSON.stringify({ outDate: new Date().toDateStr() })
                })
            }
        }
    },

    /**
    * @desc : 给表单赋值
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
    setValuesByEdit(data) {
        console.log("setValuesByEdit", data);
        let cardList_ = this.data.cardList
        let contentList_ = this.data.contentList
        let sumitemAmt = 0
        let formType = this.data.formType
        //  出库状态-已出库
        if (data.outStatus == Constants.outStatus.unOutBound) {
            //查询采购订单表 未出库的 详细 
            this.setData({
                buttonList: [{
                    name: 'merge',
                    title: mixins.$t("close")
                }],
            })
        } else {
            this.setData({
                buttonList: [{
                    name: 'merge',
                    title: mixins.$t("outProcessing")
                }],
            })
        }

        sumitemAmt = Number(data.outingQty) * Number(data.outingAmt)
        cardList_.forEach(card => {
            if (card.name === 'items') {
                if (formType == 1) {
                    card.info = "（" + mixins.$t("outboundProcessing") + "）"
                    card.color = "#E4002B"
                } else {
                    card.info = "（" + mixins.$t("checkouted") + "）"
                    card.color = "#1B365D"
                }
                card.itemAmt = sumitemAmt
            }
        })
        contentList_[1].content = sumitemAmt

        // 明细的最大出库办理的量
        data.goodsList.forEach(element => {
            if (this.data.item.outType == Constants.outType.purReturn) {
                element['outingQty_max'] = -1
                element['outingQty_min'] = -1 * Math.abs(element.outingQty)
            } else {
                element['outingQty_max'] = element.outingQty
                element['outingQty_min'] = 1
            }
            // 显示库区和可售量开关
            element.usableQtyInsufficientFlag = true
        })

        // 刷新商品明细 显示 查看更多
        let card = this.data.cardList.filter(it => it.name == 'items');
        this.selectComponent('#' + this.data.formName).handleContentObj(card[0])

        this.setData({
            itemData: data,
            cardList: cardList_,
            contentList: contentList_,
            formData: JSON.stringify(data),
            sumitemAmt
        })

    },
    /**
     * @desc   : 绑定数据-选择页面返回的逻辑处理
     * @author : 姜永辉
     * @date   : 2024年3月12日
     */
    chooseData(e) {
        let formData = JSON.parse(this.data.formData)
        let cardList_ = this.data.cardList
        let code = e.detail.code
        let data = e.detail.data.data
        if (code == "supId") { //供应商
            formData.supId = data.id
            formData.supName = data.name
        }
        if (code == "staffId") { //员工
            formData.staffId = data.id
            formData.staffName = data.name
            formData.orgId = data.orgId
            formData.orgName = data.orgName
        }
        if (code == "orgId") { //部门
            formData.orgId = data.id
            formData.orgName = data.name
        }
        if (code == "outReason") { //出库原因
            formData.outReason = data.id
            formData.outReasonName = data.name
        }
        if (code == "outObject") { //出库对象
            formData.outObject = data.id
            formData.outObjectName = data.name
            formData.objType = data.objType
        }
        this.setData({
            cardList: cardList_,
            formData: JSON.stringify(formData)
        })
    },

    /**
    * @desc : 外露设置产品方法 
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
    setGoods(e) {
        let contentList_ = this.data.contentList
        let cardList = this.data.cardList
        let formData = JSON.parse(this.data.formData)
        let totalAmout = Number(0)
        // 各个明细的金额数量
        formData.goodsList.forEach(element => {  //循环出商品总共价格 
            element.outingAmt = element.priceStandard * element.itemQty
            element.outingQty = element.itemQty
            element.priceOut = element.priceStandard
            element.outAmt = 0     //  已出库金额
            element.outQty = 0     //  已出库数量
            // 显示库区和可售量开关
            element.usableQtyInsufficientFlag = true
            totalAmout += Number(element.priceStandard * element.itemQty)
        })
        // 左下角的合计金额
        contentList_.forEach(card => {
            if (card.code === 'amount') {
                card.content = totalAmout
            }
        })
        // 明细的合计金额
        cardList.forEach(card => {  //循环出商品总共价格
            if (card.name === 'items') {
                //合计金额
                card.itemAmt = totalAmout
            }
        })
        this.setData({
            contentList: contentList_,
            cardList,
            formData: JSON.stringify(formData)
        })
    },

    /**
     * @desc : 保存数据服务--校验
     * @date : 2024/2/1 15:49
     * @author : 姜永辉
     */
    validData() {
        let formData = JSON.parse(this.data.formData)
        if (formData.goodsList == null || formData.goodsList.length == 0) {
            util.showToast(mixins.$t("chooseGoodsInfo"));
            return false
        }
        // 明细的数量和仓库不能为空
        for (let index = 0; index < formData.goodsList.length; index++) {
            const element = formData.goodsList[index];
            if (element.whId == null) {
                util.showToast(mixins.$t("chooseWh"));
                return false
            }
            if (element.itemQty == null || element.itemQty == '' || element.itemQty == 0) {
                util.showToast(mixins.$t("inputWords") + "[" + element.skuCode + "]" + mixins.$t("count"));
                return false
            }
        }
        return true
    },

    /**
     * @desc : 保存的參數設置
     * @date : 2024/2/1 15:49
     * @author : 姜永辉
     */
    setParams(params) {
        let btnFormData = this.data.btnFormData ? JSON.parse(this.data.btnFormData) : ''
        let formData = JSON.parse(this.data.formData)
        // 新增编辑的
        params.outId = formData.outId
        // 总单的 出库中数量和金额合计
        params.outingAmt = formData.goodsList.sum("outingAmt")   //金额
        params.outingQty = formData.goodsList.sum("outingQty")     //一共的商品数量
        params.outAmt = 0     //  已出库金额
        params.outQty = 0     //  已出库数量         
        params.flgAutoHandle = btnFormData ? btnFormData.flag : false //自动出出库标识 
        // params.fromId = this.data.purIdArray  //来源id
        // params.fromNo = formData.fromNo  //来源单号
        params.orgId = formData.orgId  //组织部门
        params.staffId = formData.staffId  // 员工
        //  // 供应商1 客户2 所有 传空
        if (formData.objType == 1) {
            params.supId = formData.outObject  // 供应商
        }
        if (formData.objType == 2) {
            params.cusId = formData.outObject  // 客户
        }
        // params.whId = formData.whId  // 仓库
        params.remarks = formData.remarks  // 备注
        params.makeStaff = app.globalData.user.staffId  // 制单人
        // 明细的顺序
        let i = 0
        formData.goodsList.forEach(it => {
            it.itemIndex = (i++)
        })
        params.itemList = formData.goodsList //商品明细
        params.annexPaths = formData.annexPaths || [] //附件 
        return params
    },

    /**
    * @desc : 保存数据服务
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
    saveData() {
        if (this.data.formMode == Constants.formMode.edit) {
            return this.excute(this.data.service, this.data.service.otheroutBoundUpdate, this.data.params)
        } else {
            return this.excute(this.data.service, this.data.service.otheroutBoundInsert, this.data.params)
        }
    },
})